#include <stdio.h>
#include <string.h>

static int _iswhite (int c)
{
  switch (c)
  {
    case ' ':
    case '\t':
    case '\r':
    case '\n':
    case EOF:
      return 1;
    default:
      return 0;
  }
}

int main (int argc, char* argv[])
{
  FILE *fin=NULL, *fout=NULL;
  enum {SKIP,COPY,POSTCOPY} state = SKIP;
  enum {NOLIB,TLIB,WLIB} lib = NOLIB;

  if
  (
    (argc != 4) ||
    (
      (argc == 2) &&
      (
         (!strcmp(argv[1], "/?")) || (!strcmp(argv[1], "--help"))
      )
    )
  )
  {
linfo:
    printf
    (
      "obj4xlib.exe -<t|w> <objects list file> <lib command file>\n"
      "-t selects Borland's TLIB librarian format for command file\n"
      "-w selects Watcom's WLIB librarian format for command file\n"
      "<objects list file> is input file with object file names, one or more per line\n"
      "<lib command file> is output file with commands for the librarian\n"
    );
    goto lend;
  }

  lib = (TLIB*((!strcmp(argv[1],"-t"))|(!strcmp(argv[1],"-T")))) |
        (WLIB*((!strcmp(argv[1],"-w"))|(!strcmp(argv[1],"-W"))));

  if (lib == NOLIB)
    goto linfo;

  fin = fopen (argv[2], "rb");
  fout= fopen (argv[3], "wb");
  if ((fin == NULL) || (fout == NULL))
  {
    printf ("failed to open a file.\n");
    goto lend;
  }

  for(;;)
  {
    int c = fgetc (fin);
    int IsWhite = _iswhite (c);

    switch (state)
    {
      case SKIP:
        if (!IsWhite)
        {
          fputs ("-+ ", fout);
          fputc (c, fout);
          state = COPY;
        }
        break;

      case COPY:
        if (!IsWhite)
        {
          fputc (c, fout);
        }
        else
        {
          state = POSTCOPY;
        }
        break;

      case POSTCOPY:
        if (!IsWhite)
        {
          if (lib == TLIB)
            fputs (" &", fout);
          fputs ("\n-+ ", fout);
          fputc (c, fout);
          state = COPY;
        }
        break;
    }

    if (c == EOF)
    {
      fputs ("\n", fout);
      break;
    }
  }

lend:
  if (fin != NULL)
    fclose (fin);
  if (fout != NULL)
    fclose (fout);

  return 0;
}
