GLOBAL  _int86x, _segread

%define param_1 bp+4
%define param_2 bp+6
%define param_3 bp+8
%define param_4 bp+10
%define param_5 bp+12
%define param_6 bp+14

;struct WORDREGS {
;    unsigned int    ax, bx, cx, dx, si, di, cflag, flags;
;};
WORDREGS.ax     equ     0
WORDREGS.bx     equ     2
WORDREGS.cx     equ     4
WORDREGS.dx     equ     6
WORDREGS.si     equ     8
WORDREGS.di     equ     10
WORDREGS.cflag  equ     12
WORDREGS.flags  equ     14


;struct BYTEREGS {
;    unsigned char   al, ah, bl, bh, cl, ch, dl, dh;
;};
BYTEREGS.al     equ     0
BYTEREGS.ah     equ     1
BYTEREGS.bl     equ     2
BYTEREGS.bh     equ     3
BYTEREGS.cl     equ     4
BYTEREGS.ch     equ     5
BYTEREGS.dl     equ     6
BYTEREGS.dh     equ     7


;union   REGS    {
;    struct  WORDREGS x;
;    struct  BYTEREGS h;
;};

;struct  SREGS   {
;    unsigned int    es;
;    unsigned int    cs;
;    unsigned int    ss;
;    unsigned int    ds;
;};
SREGS.es        equ     0
SREGS.cs        equ     2
SREGS.ss        equ     4
SREGS.ds        equ     6


int86xLocals.Vector     equ     0
int86xLocals.Code       equ     4
int86xLocals_size       equ     14


SEGMENT _TEXT PUBLIC CLASS=CODE USE16

;int int86x(int intno, union REGS *inregs, union REGS *outregs,
;           struct SREGS *segregs)
_int86x:
;{
        push    bp
        mov     bp, sp

;        void    (far * Vector)(void);
;        char    Code[10];
        sub     sp, int86xLocals_size
        push    si
        push    di

;
;        /* Save caller context */

;asm     push    ds
        push    ds

;        /* Prepare Interrupt call */

;asm     lea     cx, Code
        lea     cx, [bp-int86xLocals_size+int86xLocals.Code]
;asm     mov     word ptr Vector, cx
        mov     [bp-int86xLocals_size+int86xLocals.Vector], cx
;asm     mov     word ptr Vector+2, ss
        mov     [bp-int86xLocals_size+int86xLocals.Vector+2], ss

;asm     mov     byte ptr Code, 055h
        mov     byte [bp-int86xLocals_size+int86xLocals.Code], 055h
;asm     mov     byte ptr Code+1, 0CDh
        mov     byte [bp-int86xLocals_size+int86xLocals.Code+1], 0CDh
;asm     mov     ax, intno
        mov     ax, [param_1]
;asm     mov     byte ptr Code+2, al
        mov     [bp-int86xLocals_size+int86xLocals.Code+2], al
;asm     mov     word ptr Code+3, 0CB5Dh
        mov     word [bp-int86xLocals_size+int86xLocals.Code+3], 0CB5Dh
;asm     cmp     al, 025h
        cmp     al, 025h
;asm     jb      SetRegs
        jb      .SetRegs
;asm     cmp     al, 026h
        cmp     al, 026h
;asm     ja      SetRegs
        ja      .SetRegs
;asm     mov     byte ptr Code+3, 036h
        mov     byte [bp-int86xLocals_size+int86xLocals.Code+3], 036h
;asm     mov     word ptr Code+4, 0068Fh
        mov     word [bp-int86xLocals_size+int86xLocals.Code+4], 0068Fh
;asm     mov     word ptr Code+6, cx
        mov     [bp-int86xLocals_size+int86xLocals.Code+6], cx
;asm     mov     word ptr Code+8, 0CB5Dh
        mov     word [bp-int86xLocals_size+int86xLocals.Code+8], 0CB5Dh

;        /* Set registers with register structure content */

;SetRegs:
.SetRegs:
;asm     LDS_    si, segregs
        mov     si, [param_4]
;asm     push    [si].es
        push    word [si+SREGS.es]
;asm     push    [si].ds
        push    word [si+SREGS.ds]
;asm     LDS_    si, inregs
        mov     si, [param_2]
;asm     mov     ax, [si].ax
        mov     ax, [si+WORDREGS.ax]
;asm     mov     bx, [si].bx
        mov     bx, [si+WORDREGS.bx]
;asm     mov     cx, [si].cx
        mov     cx, [si+WORDREGS.cx]
;asm     mov     dx, [si].dx
        mov     dx, [si+WORDREGS.dx]
;asm     mov     di, [si].di
        mov     di, [si+WORDREGS.di]
;asm     mov     si, [si].si
        mov     si, [si+WORDREGS.si]
;asm     pop     ds
        pop     ds
;asm     pop     es
        pop     es

;        /* Call the interrupt routine */

;        (* Vector)();
        call    far [bp-int86xLocals_size+int86xLocals.Vector]

;        /* Set register structure with registers */

;asm     pushf
        pushf
;asm     pushf
        pushf
;asm     push    si
        push    si
;asm     push    ds
        push    ds
;asm     push    es
        push    es
;#if     !LDATA
;asm     mov     ds, [bp-20]
;#endif
        mov     ds, [bp-20]
;asm     LDS_    si, segregs
        mov     si, [param_4]
;asm     pop     [si].es
        pop     word [si+SREGS.es]
;asm     pop     [si].ds
        pop     word [si+SREGS.ds]
;asm     LDS_    si, outregs
        mov     si, [param_3]
;asm     pop     [si].si
        pop     word [si+WORDREGS.si]
;asm     pop     [si].flags
        pop     word [si+WORDREGS.flags]
;asm     pop     [si].cflag
        pop     word [si+WORDREGS.cflag]
;asm     and     word ptr [si].cflag, 1
        and     word [si+WORDREGS.cflag], 1
;asm     mov     [si].di, di
        mov     [si+WORDREGS.di], di
;asm     mov     [si].dx, dx
        mov     [si+WORDREGS.dx], dx
;asm     mov     [si].cx, cx
        mov     [si+WORDREGS.cx], cx
;asm     mov     [si].bx, bx
        mov     [si+WORDREGS.bx], bx
;asm     mov     [si].ax, ax
        mov     [si+WORDREGS.ax], ax
;asm     pop     ds
        pop     ds
;asm     jz      int86Ok
;asm     push    ax
;        __IOerror(_AX);
;asm     pop     ax

;int86Ok:
;        return(_AX);
;}
        pop     di
        pop     si
        add     sp, int86xLocals_size
        pop     bp
        ret

;void segread(struct SREGS *segp)
_segread:
;{
        push    bp
        mov     bp, sp
        push    si
;#if (LDATA)
;asm mov bx,es           /* save ES */
;#endif
;asm LES_ si,segp
        mov     si, [param_1]
;#if (LDATA)
;asm mov es:[si].es,bx
;#else
;asm mov [si].es,es
        mov     [si+SREGS.es], es
;#endif
;#if (LPROG)
;asm mov ax,[bp+4]       /* Retrieve callers CS from stack */
;asm mov ES_ [si].cs,ax
;#else
;asm mov ES_ [si].cs,cs
        mov     [si+SREGS.cs], cs
;#endif
;asm mov ES_ [si].ss,ss
        mov     [si+SREGS.ss], ss
;#ifdef __HUGE__
;asm mov ax,[bp-4]       /* Retrieve saved DS from stack (SI pushed first) */
;asm mov ES_ [si].ds,ax
;#else
;asm mov ES_ [si].ds,ds
        mov     [si+SREGS.ds], ds
;#endif
;#if (LDATA)
;asm mov es,bx           /* Restore ES */
;#endif
;}
        pop     si
        pop     bp
        ret
