#include <stdlib.h>
#include <dos.h>

#ifdef __cplusplus
extern "C" {
#endif
extern int _GetIF();
#ifdef __cplusplus
}
#endif

void interrupt (*getvect(int intno))()
{
  void far* p;

  if ((intno < 0) || (intno >= 0x100))
  {
    p = NULL;
  }
  else
  {
    unsigned far* pp = MK_FP(0,(const)(intno*4));
    int i = _GetIF();
    disable();
    p = MK_FP((const)pp[1],(const)pp[0]);
    if (i) enable();
  }

  return (void interrupt(*)())p;
}

void setvect(int intno, void interrupt (*isr) ( ))
{
  unsigned far* p;
  int i;

  if ((intno < 0) || (intno >= 0x100))
    return;

  i = _GetIF();
  disable();
  p = MK_FP(0,((const)(intno*4)));
  p[0] = FP_OFF(isr);
  p[1] = FP_SEG(isr);
  if (i) enable();
}
