#ifndef _COMMON_DEFINES_H_
#define _COMMON_DEFINES_H_

#include <stddef.h>

// MIN() and MAX() macros:
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))

// ABS() and SGN() macros:
#define ABS(a) (((a)<0)?-(a):(a))
#define SGN(a) (((a)<0)?-1:(((a)>0)?1:0))

// This macro returns offset of a member of a structure
#define GetMemberOffset(StructType,MemberName)\
  ((size_t)&((StructType*)0)->MemberName)

#define GetArrayElementCount(Array)\
  (sizeof(Array)/sizeof(Array[0]))

#ifdef __TURBOC__
 #ifdef inline
  #undef inline
 #endif
  #define inline
#endif

#if defined (__GNUC__)
 #ifndef far
  #define far
 #endif
#endif

#endif // _COMMON_DEFINES_H_
