#include <stdlib.h>
#include <dos.h>

#include "alloc.h"

extern char _heapbase[];
extern unsigned _stklen;

tAlloc nearheap_Alloc;
int nearheap_IsInit = 0;

static int nearheap_Init()
{
  tAllocInit AllocInit;

  AllocInit.pHeapBegin = _heapbase;
  AllocInit.HeapSize = 0x10000UL - _stklen - (size_t)_heapbase;
  AllocInit.PageSize = 0;
  AllocInit.pMapPages = NULL;
  AllocInit.pUnmapPages = NULL;

  return ALLOC_Init (&nearheap_Alloc, &AllocInit);
}

void* malloc (size_t size)
{
  if (!nearheap_IsInit)
  {
    nearheap_IsInit = nearheap_Init();
    if (!nearheap_IsInit)
      return NULL;
  }
  return ALLOC_Alloc (&nearheap_Alloc, size);
}

void free (void *buf)
{
  if (!nearheap_IsInit)
    return;
  ALLOC_Free (&nearheap_Alloc, buf);
}
