#include <dos.h>
#include <string.h>

#define ATTEMPTS        5

void _GetDate (unsigned* pYear, unsigned* pMonth, unsigned* pDay)
{
  union REGS regs;
  struct SREGS segregs;
  int i;

  memset (&regs, 0, sizeof(regs));
  for (i=0; i<ATTEMPTS; i++)
  {
    regs.h.ah = 4;
    if (int86x (0x1a, &regs, &regs, &segregs))
      break;
  }

  *pYear  = (regs.h.ch >> 4)  * 1000;
  *pYear += (regs.h.ch & 0xf) *  100;
  *pYear += (regs.h.cl >> 4)  *   10;
  *pYear += regs.h.cl & 0xf;

  *pMonth = (regs.h.dh >> 4) * 10;
  *pMonth += regs.h.dh & 0xf;

  *pDay = (regs.h.dl >> 4) * 10;
  *pDay += regs.h.dl & 0xf;
}

void _GetTime (unsigned* pHour, unsigned* pMinute, unsigned* pSecond)
{
  union REGS regs;
  struct SREGS segregs;
  int i;

  memset (&regs, 0, sizeof(regs));
  for (i=0; i<ATTEMPTS; i++)
  {
    regs.h.ah = 2;
    if (int86x (0x1a, &regs, &regs, &segregs))
      break;
  }

  *pHour = (regs.h.ch >> 4) * 10;
  *pHour += regs.h.ch & 0xf;

  *pMinute = (regs.h.cl >> 4) * 10;
  *pMinute += regs.h.cl & 0xf;

  *pSecond = (regs.h.dh >> 4) * 10;
  *pSecond += regs.h.dh & 0xf;
}

void _GetDateAndTime (unsigned* pYear, unsigned* pMonth, unsigned* pDay,
                      unsigned* pHour, unsigned* pMinute, unsigned* pSecond)
{
  unsigned Year, Month, Day;
  // Get date and time accounting for possible midnight rollover:
  do
  {
    _GetDate (&Year, &Month, &Day);
    _GetTime (pHour, pMinute, pSecond);
    _GetDate (pYear, pMonth, pDay);
  } while
    (
      (Day   != *pDay) ||
      (Month != *pMonth) ||
      (Year  != *pYear)
    );
}

#if 0
#include <stdio.h>
int main()
{
  unsigned Year, Month, Day, Hour, Minute, Second;
  _GetDateAndTime
  (
    &Year, &Month, &Day,
    &Hour, &Minute, &Second
  );
  printf
  (
    "date(YYYY-MM-DD): %04u-%02u-%02u\n"
    "time(HH:MM:SS):     %02u:%02u:%02u\n",
    Year, Month, Day,
    Hour, Minute, Second
  );
  return 0;
}
#endif
